/* include files *
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <string.h>   /* was "strings" */
#include <values.h>
/*#include <malloc.h>   done in xv.h, with machine-specific file names */

#include <X11/Xos.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>


#ifndef MAIN
#define WHERE extern
#else
#define WHERE
#endif


#include "xv.h"
#include "GraphicsGems.h"


void exit();

struct point2d {
float x,y;
};
typedef struct point2d Point2d;

Point2d *makepoint();

struct barycoord {
float u,v,w;
};
typedef struct barycoord Barycoord;



struct internalpic {
int wide, high;
int originalnumcolors;
int numcolors;
int cmap [3][256];      /* bad design, I know */
int numbits;          /* 8 or 24 */
unsigned char *data;          /* 8 or 32 */
};
typedef struct internalpic InternalPic;

WHERE int ALLSAMEPICS;  /* TRUE if begin, end, and outputpic have same colormaps */




WHERE InternalPic startingpic, endingpic, backgroundpic, outputpic;


#define CENTERX(f,x,str) ((x)-XTextWidth(f,str,strlen(str))/2)
#define CENTERY(f,y) ((y)-((f->ascent+f->descent)/2)+f->ascent)


/* X stuff */

/* This stuff is already declared once in "xv.h" so I don't know
   why it is here. This "WHERE" thing doesn't seem to work either!
   Never mind I'll #ifdef __hpux it...
                                                        -- Rik    */

#ifdef __hpux
extern Display       *theDisp;
extern int           theScreen;
extern Colormap      theCmap;
extern Window        rootW, mainW;
extern GC            theGC;
extern Font          mfont;
extern XFontStruct   *mfinfo;
extern Visual        *theVisual;
extern XImage        *theImage;
extern int           expand;
extern unsigned long  cols[256];
extern char          *cmd;
#else
WHERE Display       *theDisp;
WHERE int           theScreen;
WHERE Colormap      theCmap;
WHERE Window        rootW, mainW;
WHERE GC            theGC;
WHERE Font          mfont;
WHERE XFontStruct   *mfinfo;
WHERE Visual        *theVisual;
WHERE XImage        *theImage;
WHERE int           expand;
WHERE unsigned long  cols[256];
WHERE char          *cmd;
#endif

WHERE int           dispcells;
WHERE unsigned long fcol,bcol;
WHERE XImage        *expImage;
WHERE int  glcolor[256];
WHERE unsigned long *pixels;  /* will malloc area for pixel array */



/* global vars */
WHERE int            iWIDE,iHIGH;
WHERE XColor         defs[256];


WHERE GGWindow GGWIN; 

/* picture sizes */
WHERE int stexWIDE, stexHIGH;   /* starting insert texture */
WHERE int etexWIDE, etexHIGH;   /* ending   insert texture */
WHERE int backWIDE, backHIGH;  /* size of background picture */

/* file names */
WHERE char *starttexfile, *endtexfile, *backtexfile;

/* sequence particulars */
WHERE int numsteps;  /* how many output stages */
WHERE int nummesh;
#define FROM 0
#define TO   1
#define MESHSIZE 256 
WHERE Point2 beginmesh[2][MESHSIZE][3];       /* mesh in begin texture space */
WHERE Point2 endmesh[2][MESHSIZE][3];         /* mesh in end   texture space */
WHERE Point2 outmesh[2][MESHSIZE][3];  /* was from mesh, to mesh */

WHERE Point2 frommesh[MESHSIZE][3];     /* mesh initial positions in output space */
WHERE Point2 tomesh[MESHSIZE][3];       /* mesh final   positions in output space */

WHERE int  eWIDE, eHIGH;   /* "expanded" output version of the picture */


WHERE int redrawxmin, redrawxmax, redrawymin, redrawymax; 

WHERE int CLOSEdist;  /* color difference in r, g, b considered zero */
WHERE int OUTPUTGIFS ;  /* whether to write out each picture */
WHERE char outgiffilename[80];  /* the name stub, to be modified %s%d */
